structure FMMind :> FMMind =
struct

(* dp00a nhf, v1.0 -- 2000. nov. 1. Hanak Peter *)

(* segdfggvnyek *)

(* getLines : instream -> TMMind.hint list
   getLines istr = az istr llomnyban lert feladvny bels alakja
*)
fun getLines istr =
      if TextIO.endOfStream istr
      then []
      else let val xs = String.tokens Char.isSpace (TextIO.inputLine istr)
	       val cs = List.mapPartial Int.fromString (List.take(xs, length xs - 1))
               val ys = String.tokens (fn c => c = #"/") (List.last xs)
               val hs = List.mapPartial Int.fromString ys 
	   in (cs, (hd hs, hd(tl hs))) :: getLines istr
	   end

(* convSol : TMMind.code list -> string
   convSol css = a css kdlista tartalma fzrknt
*)
fun convSol css =
      let fun convAppendSpace c = Int.toString c ^ " "
in
    concat(map (fn cs => (concat(map convAppendSpace cs)) ^ "\n") css)
end

(*  mmind_in : string -> int * TMMind.hint list
    mmind_in f = 
     Az f szveges llomnybl beolvasott maximlis kdrtket s a
     sgs-listt adja eredmnyl.
*)
fun mmind_in f = 
    let 
	val istr = TextIO.openIn f
	val mx = valOf(Int.fromString(TextIO.inputLine istr))
	val brd = getLines istr
	val _ = TextIO.closeIn istr
    in
	(mx, brd)
    end

(* mmind_out : string * TMMind.code list -> unit
   mmind_out (m, css)
     A css kdlistt kirja az m szveges llomnyba. 
*)
fun mmind_out (m, css) =
      let val ostr = TextIO.openOut m
	  val _ = TextIO.output(ostr, convSol css)
      in
	  TextIO.closeOut ostr
      end

(* solve : string * string -> string
   solve (f, m) 
     Beolvas egy feladvnyt az f szveges llomnybl s kirja az sszes
     megoldst az m szveges llomnyba.  Ehhez termszetesen szksge van
     az MMind.mmind fggvnyre. Eredmnye a feladvny nevt, a kd hosszt
     s a futsi idt mp-ben tartalmaz fzr.
*)
fun solve (f, m) =
    let val (mx, sls) = mmind_in f
	val ostr = TextIO.openOut m
	val starttime = Timer.startCPUTimer()
	val css = MMind.mmind(mx, sls)
	val {usr=tim,...} = Timer.checkCPUTimer starttime
	val _ = TextIO.output(ostr, convSol css)
	val _ = TextIO.closeOut ostr
	val t = "Table: " ^ f ^ ", " ^
                Int.toString(length css) ^ " solution(s), " ^
		"time: " ^ Time.fmt 2 tim ^ " sec\n"
    in
	t
    end

end
